#include "ast.h"
#include <map>

//-- Body of big Node constructor
Node::Node(int a1, int a2, const string& a4, 
     Node *a5, Node *a6,Node *a7, Node *a8, Node *a9) 
{
  ntype = a1; ibVal = a2; idVal = a4;
  if (a5 != 0) { child.push_back(a5);
    if (a6 != 0) { child.push_back(a6);
      if (a7 != 0) { child.push_back(a7);
	if (a8 != 0) { child.push_back(a8);
	  if (a9 != 0) { child.push_back(a9); }}}}}
  if (ntype % 2 == 0) child.push_back(NULL);
}


/****************************************************
 * addToBack
 ****************************************************/
void addToBack(Node* L, Node *nxt) 
{ 
  if (L->child.back() == NULL) 
    L->child.back() = nxt; 
  else 
    addToBack(L->child.back(),nxt); 
}


/****************************************************
 * displayAST & helper functions
 ****************************************************/
static void assignMarks(Node *p, int &nxt, map<Node*,int> &mark) { 
  if (p) { 
    mark[p] = nxt++; 
    for(int i = 0; i < p->child.size(); ++i) 
      assignMarks(p->child[i],nxt,mark); 
  }
}

static void dothelp(ostream &out, Node *p, map<Node*,int> &mark)
{
  out << mark[p] << "[ label=\"";
  out << "ntype=" << p->ntype << "\\n";
  out << "ibVal=" << p->ibVal << "\\n";
  out << "idVal=" << p->idVal << "\" ];" << endl;
  for(int i = 0; i < p->child.size(); ++i)
    if (p->child[i] != NULL) 
      out << mark[p] << " -> " << mark[p->child[i]] << ";" << endl;
  for(int i = 0; i < p->child.size(); ++i)
    if (p->child[i] != NULL) 
      dothelp(out,p->child[i],mark);
}

void dot(ostream &out, Node *root)
{
  map<Node*,int> mark;
  int n = 0; 
  assignMarks(root,n,mark);
  out << "digraph G {" << endl;
  dothelp(out,root,mark);
  out << "}" << endl; 
}

void displayAST(Node *root)
{  
  ofstream fout("tmp.txt");
  dot(fout,root);
  system("dot -Tps tmp.txt | /home/wcbrown/bin/fixdotps > tmp.ps");
  system("ggv tmp.ps&");
}

/****************************************************
 * addCloseScopeStmts
 ****************************************************/
void addCloseScopeStmts(Node* T)
{
  if (T == 0) return;
  for(int i = T->child.size() - 1; i >= 0; --i) 
    addCloseScopeStmts(T->child[i]);
  if (T->ntype % 2 == 1) return;
  if(T->ntype == _new) 
    addToBack(T, new Node(_endscope,0,T->child[0]->idVal));
}
